#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <deque>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <utility>
#include <vector>
//#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace std;

#define int long long
#define ld long double

#define mp make_pair
using ll = long long;

const int C = 550;

const int MOD = 998244389;
const int inf = 1e12+1;
const ld EPS = 1e-12;
const int N = 2e5 + 5;


int n;
vector<pair<int, int>> a(13);

vector<vector<int>> g(13, vector<int>(13, inf));
int dp[(1 << 13)][13];

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int dist = (a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second);
            g[i][j] = dist;
            g[j][i] = dist;
        }
    }

    for(int i = 0; i < 1 << n; i++){
        for(int j = 0; j < n; j++){
            dp[i][j] = 1e18;
        }
    }

    dp[1][0] = 0;

    for(int i = 0; i < n; i++) dp[1 << i][i] = 0;

    for(int m = 2; m < 1 << n; m++){
        for(int i = 0; i < n; i++){
            if((m >> i) & 1){
                int mwi = m ^ (1 << i);
                for(int j = 0; j < n; j++){
                    if(i != j && (m >> j) & 1){
                        dp[m][i] = min(dp[m][i], dp[mwi][j] + g[i][j]);
                    }
                }
            }
        }
    }

    int ans = 1e18, idx = -1;
    for(int i = 0; i < n; i++){
        if(ans > dp[(1 << n) - 1][i]){
            ans = dp[(1 << n) - 1][i];
            idx = i;
        }
    }

   // cout << ans << endl;

    int m = (1 << n) - 1;
    vector<int> res;
    while(m != 0){
        res.push_back(idx);
        int mwi = m ^ (1 << idx);
        bool fl = 1;
        for(int j = 0; j < n; j++){
            if(idx != j && (m >> idx) & 1 && dp[mwi][j] + g[idx][j] == dp[m][idx]){
                fl = 0;
                idx = j;
                break;
            }
        }
        if(fl) break;
        m = mwi;
    }

    ld calc = 0;
    for (int i = 0; i < (int)res.size() - 1; ++i) {
        calc += sqrt((ld)g[res[i]][res[i + 1]]);
    }
    cout << fixed << setprecision(8) << calc << '\n';




}






signed main() {
    ios_base ::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
