#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <deque>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <utility>
#include <vector>
//#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace std;

#define int long long
#define ld long double

#define mp make_pair
using ll = long long;

const int C = 550;

const int MOD = 998244389;
const int inf = 1e12+1;
const ld EPS = 1e-12;
const int N = 2e5 + 5;


int n;
vector<pair<int, int>> a(13);

vector<vector<int>> g(13, vector<int>(13, inf));


void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int dist = (a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second);
            g[i][j] = dist;
            g[j][i] = dist;
        }
    }

    if (n == 2) {
        ld res = sqrt((ld)g[0][1]);
        cout << fixed << setprecision(7) << res;
        return;
    }


}






signed main() {
    ios_base ::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
