#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <deque>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <utility>
#include <vector>
//#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace std;

#define int long long
#define ld long double

#define mp make_pair
using ll = long long;

const int C = 550;

const int MOD = 998244389;
const int inf = 1e18;
const ld EPS = 1e-12;





void solve() {
    int a, b;
    cin >> a >> b;
    if (a <= 0 || b <= 0) {
        cout << "no";
        return;
    }
    string path;
    cout << "R";
    long long left_n = 0, left_d = 1, right_n = 1, right_d = 0;
    while (true) {
        int mid_n = left_n + right_n;
        int mid_d = left_d + right_d;
        if (a * mid_d == mid_n * b) {
            break;
        } else if (a * mid_d < mid_n * b) {
            path += 'L';
            right_n = mid_n;
            right_d = mid_d;
        } else {
            path += 'R';
            left_n = mid_n;
            left_d = mid_d;
        }
        if (mid_n > 1e6 || mid_d > 1e6) {
            cout << "no";
            return;
        }
    }
    cout << path;
}






signed main() {
    ios_base ::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
